#!/bin/perl
use Getopt::Std;
getopts('ht:');
if ( $opt_h )
{ print "USAGE:\n";
  print "       slideshow.pl [-tTitle] file-expr\n\n";
  print "E.G.   slideshow.pl '*.jpg'\n\n";
  print "Prepares a html slideshow. HOW TO:\n";
  print "(1) Move slides to a directory and cd to that directory\n";
  print "(2) Run slideshow-thumbnails '*,jpg'\n";
  print "(3) Run slideshow.pl\n";
  print "(4) Check with internet browser file://directory/\n";
  print "(5) cd ../ and tar cfv file.tar directory\n";
  print "(6) move tar file to an http server.\n\n";
  exit
  }
$title="HGS Slide Show";
if ( $opt_t ){ $title="$opt_t" }

@slides=`ls @ARGV | sed 's/ //g'`;

open (OUTIX,">","index.html"); 
print OUTIX
'<!DOCTYPE html PUBLIC "-//w3c//dtd html 4.0 transitional//en">'."\n".
'<html>'."\n".
'<head>'."\n".
'  <meta http-equiv="Content-Type"'."\n".
' content="text/html; charset=iso-8859-1">'."\n".
'  <meta name="GENERATOR"'."\n".
' content="Mozilla/4.76 [en] (Win98; U) [Netscape]">'."\n".
'  <title>'."$title".'</title>'."\n".
'</head>'."\n".
'<body>'."\n";
print "$#slides $slides[$#slides]\n";
$i=0;
while ($i < $#slides ) 
{ $s=chomp($slides[$i]);
  if ( $i < $#slides ){
     $slide=$slides[$i+1];
     $slide=~ /(\S*)\.jpg/; $sn=$1
     }
  if ( $i > 0){ 
     $slide=$slides[$i-1];
     $slide=~ /(\S*)\.jpg/; $sp=$1
     }
  $slide=$slides[$i];
  $slide=~ /(\S*)\.jpg/; $s=$1;
  print "$slides[$i] $s\n";
  print OUTIX '<A href="'."$s.html".'"> <img src="Thumbs/'."$slide".'" height=120></A>'."\n";
  open OUTHL,">",$s.".html";
  print OUTHL
'<!DOCTYPE html PUBLIC "-//w3c//dtd html 4.0 transitional//en">'."\n".
'<html>'."\n".
'<head>'."\n".
'  <meta http-equiv="Content-Type"'."\n".
' content="text/html; charset=iso-8859-1">'."\n".
'  <meta name="GENERATOR"'."\n".
' content="Mozilla/4.76 [en] (Win98; U) [Netscape]">'."\n".
'  <title>'.$slide.'</title>'."\n".
'</head>'."\n".
'<body>'."\n";
  if ( $sn ){ print OUTHL '<a href="'.$sn.'.html">NEXT</a>&nbsp&nbsp'."\n" }
  if ( $sp ){ print OUTHL '<a href="'.$sp.'.html">PREVIOUS</a>&nbsp&nbsp'."\n" }
  print OUTHL '<a href="index.html">HOME</a><p>'."\n";
  print OUTHL '<img src="'.$slide.'" height=900>'."\n";
  print OUTHL '</body></html>'."\n";
  close (OUTHL);
  $i++
   }
print OUTIX "</body></html>\n";
close (OUTIX);
exit
 
