#!/opt/perl5/bin/perl
# c:\perl5\bin\perl
if ( $ARGV[0] eq "-h" ){
   print "USAGE:    checkapl.pl file [file...]\n";
   print "          checkapl.pl -w file\n\n";
   print "PURPOSE:  checks air pressure loading files for problems\n\n";
   print "OPTIONS:\n";
   print " -w    -  special column part rewrite; user, edit the program\n";
   print "          according to specific problem.\n";
   exit }

if ( $ARGV[0] eq "-w" ){
    shift @ARGV;
    while (<>){
	chomp;
	print substr($_,0,18).substr($_,19)."\n"
	}
    exit }

while ( $ARGV[0] ){
open (FH,$ARGV[0]) || die "$! file $ARGV[0]" ;
print "\nFile $ARGV[0]\n";
$i=0; $mc=1; $pc=0;
$ct=0; $mt=1; $pt=0;
$mn=1; $pn=0;
$mv=1; $pv=0;

while (<FH>){
chomp; $i++; @rec=split(/ +/);
 $l = substr($_,14,1).substr($_,21,1).substr($_,31,1).substr($_,41,1);
$tn = substr($_,15,2);
 $n = substr($_,1,1);
 $d = $rec[1];

if ( ! ( $tn/6+1 == $n ) ){
     if ( $mn ){ print "First #-number problem at line $i: $n, tn=$tn\n";
                 print "Date = $d\n\n";
                 $mn=0 }
                 $pn++ }

if ( $ct ){ $dt = $tn - $to; if ( $dt < 0 ){ $dt += 24 }
            $tn = $tn * 1;
            if ( ! ( $dt ==  6 ) ||
                !( ( $tn ==  0 ) ||
                   ( $tn ==  6 ) ||
                   ( $tn == 12 ) ||
                   ( $tn == 18 ) ) ){
                 if ( $mt ){ print "First time problem at line $i: tn=$tn dt=$dt\n";
                             print "Date = $d\n\n";
                             $mt=0 }
                 $pt++ }
          }
$to = $tn; $ct = 1;

if ( $l ne ":..." ){ if ( $mc ){ print "First column problem at line $i\n";
                                 print "Date = $d\n\n";
                                 $mc=0 }
                    $pc++ } 

$vr = $rec[2]; $ve = $rec[3]; $vn = $rec[4];
if ( (abs($vr) > 0.1 ) ||
     (abs($ve) > 0.01) ||
     (abs($vn) > 0.01) ){
     if ( $mv ){ print "First large value at line $i: $vr,$ve,$vn\n";
                 print "Date = $d\n\n";
                 $mv=0 }
     $pv++ }

#print substr($_,0,18).substr($_,19)."\n"
}
if ( $i ){
print "In total $i records. Problem records:\n";
print "   bad alignment of columns: $pc\n";
print "   bad time succession:      $pt\n";
print "   bad #-numbers:            $pn\n";
print "   bad values:               $pv\n"; }

shift @ARGV }
exit
